#!/usr/local/bin/perl
# !+-------------------------------------------------------------------------
#    Name:  dbamon_downtime_edit.pl
# !*-------------------------------------------------------------------------

chop($P = `basename $0`);
$| = 1;
require "cgi_handlers.pl";
use DBI;
$SIG{'INT'} = 'IntHandler';
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
chop($hostname = `hostname`); 
undef %rqpairs;

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

#---- See if DBAmon is configured to use Oracle (it should be)
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  #$dbms = "oracle";
  $sql = ""; 
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b></font>\n";
}

#-----------------------------------------------------------------------------
sub error 
#-----------------------------------------------------------------------------
{
  local($errorMsg) = $_[0];

  print "Content-type: text/html\n\n";
  print "<head><title> Fatal Error</title></head>";
  print "<body>";

  print "<h2> The following error occured - $date</h2>";
  print "<hr noshade>";
  print "</hr noshade>";
  print "<h4> $errorMsg</h4>";
  $sqlerror = $DBI::errstr;
  print "<br>SQL statement: $sql";
  print "<br>SQL error: $sqlerror";

  print "</body>";
  print "</html>";

  exit(1);
}

#-----------------------------------------------------------------------------
sub connectDB 
#-----------------------------------------------------------------------------
{
  $dbh = ""; 
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub writeDT
#-----------------------------------------------------------------------------
{
  $dtdata_in = $rqpairs{'text'};
  $tmpfl      = "/tmp/${P}_tmp_${$}.txt"; 
  ##&msg("DEBUG - dtdata=<pre>$dtdata_in</pre>"); 

  $lineswritten = 0;
  foreach (split(/\n/,$dtdata_in))
  {
    #---- There is a stupid ^M at the end of every line. chop it
    chop; 
    next if /^$/;
    $dtdata_out .= "$_\n";   
    $lineswritten++; 
  }

  $dtdata_out .= "#---- Edited by $P on $date - Client: $ENV{'REMOTE_HOST'}\n"; 
  $lineswritten++; 

  &msg("There are $lineswritten lines to be written"); 
  &msg("Writing DT data to $tmpfl"); 
  open(DT,">$tmpfl") || &error("Cannot open output $dtfile - $!"); 
  print DT $dtdata_out; 
  close(DT); 

  $cmd = "remsh $hostname -l dbamon 'cat $tmpfl > $dtfile'"; 
  &msg("Moving temp file to $dtfile - cmd=$cmd"); 
  $saveoutput = `$cmd 2>&1`; 
  &msg("Command output: $saveoutput"); 
  unlink($tmpfl); 

  $verify  = "================= Top of File ===================\n"; 
  $verify .= `cat $dtfile`; 
  $verify .= "================ Bottom of File =================\n"; 
  $verify .= `wc -l $dtfile`;
  &msg("For verification purposes, DT file $dtfile and line count after changes:<pre><font size=2>$verify</font></pre>"); 
  ##system("env > /tmp/webenv"); 
}

#-----------------------------------------------------------------------------
sub createDT
#-----------------------------------------------------------------------------
{
  &msg("Downtime file dtfile=$dtfile does not exist - Creating"); 
  open(DT,">$dtfile") || &error("Cannot open output $dtfile - $!"); 
  print DT "#---- (File $dtfile created $date by $P)
#---- Do not change column alignment. Parameters must begin in
#---- column 1 and Data must begin in column 10 
#<-Parms-> <-Data------------------------------------------------------->
Key:       $downtime_key
Desc:      
Prevent:   
  "; 
  close(DT);
  system("chmod 775 $dtfile"); 
  system("chgrp itc $dtfile"); 
}

#-----------------------------------------------------------------------------
sub readDT
#-----------------------------------------------------------------------------
{
  if (! -e "$dtfile")
  {
    &createDT;
  }

  &msg("Reading dtfile=$dtfile"); 
  open(DT,"$dtfile") || &error("Cannot open input $dtfile - $!"); 
  $dtdata = ""; 
  $linesread = 0;
  while (<DT>) 
  {
    $dtdata .= $_;  
    $linesread++;
  }
  close(DT); 

  &msg("Read $linesread lines from $dtfile"); 
  &msg("To Cut/Paste use Ctrl+c and Ctrl+v"); 
  &msg("Make changes and click SAVE CHANGES below"); 
  print "
    <form method=\"POST\" action=\"/cgi-bin/$P\?$downtime_key?Process\">
    <style>
    .tattr { background-color: black; color: linen }
    </style>
    <textarea class=tattr NAME='text' COLS=150 ROWS=10 WRAP='off'>$dtdata</textarea>
    <br><font size=2>
    <p><input type=submit value=' Save Changes'>
    </form>
  "; 

  #---- Save copy of this file
  chop($dtfileshort = `basename $dtfile`); 
  $dtfilesave = "/opt/dbamon/adm/downtime_save/" . $dtfileshort; 
  $cmd = "remsh $hostname -l dbamon 'mkdir /opt/dbamon/adm/instances_save 2>/dev/null;cat $dtfile >> $dtfilesave'"; 
  &msg("Saving backup copy of DT file to $dtfilesave - cmd=$cmd"); 
  $saveoutput = `$cmd 2>&1`; 
  &msg("Command output: $saveoutput"); 
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  local($Signal) = @_;
  &msg("Signal=$Signal received - exiting"); 
  exit(0);
}

#------------------------------------------------------------------------------
sub CheckForEvilness
#------------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&get_request;

$downtime_key = (split(/\?/,$ARGV[0]))[0];
$verb         = (split(/\?/,$ARGV[0]))[1];

$downtime_key =~ s/\\$//;

$dtfile = "/opt/dbamon/adm/downtime/dt_$downtime_key.txt"; 

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "Content-type: text/html\n\n
  <title>DBAmon Downtime Editor</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>DT Downtime Post-Mortem Edit</center>
  </table>
  <table width=750> $links_include </table>
  <hr>
";

&msg("Starting - verb=$verb downtime_key=$downtime_key dtfile=$dtfile"); 

#---- Connect to DB (may not need this)
&connectDB;

#---- Process
if ($verb eq "Process")
{
  &writeDT;
  $goback = "-2"; 
}
else
{
  #system("echo '' | mailx -s 'monitor--$P dtfile=$dtfile ($ENV{'REMOTE_HOST'})' bill.border\@thecompany.com");
  &readDT;
  $goback = "-1"; 
}

print "<p>
<script language='JavaScript'> function back() { history.go($goback); } </script>
<font size=2><b><a href='javascript:back()'>Click Here</a> to return</b></font>
<p>
";

&msg("Done"); 
exit;
