# -----------------------------------------------------------------------------
# Changes:
#   BB 02Dec04 - Added code to not run this check if lsnrstack is null
# -----------------------------------------------------------------------------
sub oraLsnr
{
  ($thishost) = @_;

  if (&check_inhib($thishost) eq "Y" || $up[$thishost] eq "I")
  {
    $up[$thishost] = "I";
    &logit("(down/inhibited)",$thishost);
    return;
  }

  if ($asmflag[$thishost])
  {
    &logit("(This check not applicable to +ASM instance)",$thishost);
    return 1;
  }

  if ($up[$thishost] eq "D")
  {
    &logit("No software download)",$thishost);
    return;
  }

  if ($up[$thishost] ne "Y")
  {
    logit("(Down)",$thishost);
    return 1;
  }

  if ($listener_check[$thishost] eq "N")
  {
    logit("(Listener_Check: Set to N)",$thishost);
    return 1;
  }

  if ($oraLsnrStack[$thishost] eq "")
  {
    &logit("No Listener Data for this instance - Skipping check",$thishost);
    return;
  }

  $lsnrstat = ""; 
  $lsnrerror = ""; 
  $tnsping = ""; 
  $tnserror = ""; 

  open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  print TMPFL6 $diagLsnrStack[$thishost];
  close(TMPFL6);

  @lines = split(/\n/,$oraLsnrStack[$thishost]);
  foreach (@lines)
  {
    &parse;
    if ($F4 eq "LSNRSTAT:")  
    { 
      $lsnrstat  = $F5;
      $lsnrerror = substr($F0,46);
    }
    if ($F4 eq "TNSPING:")  
    { 
      $tnsping  = $F5;
      $tnserror = substr($F0,45);
    }
    if ($F4 eq "LSNRRESTARTED:")  
    { 
      &event("W",$thishost,"Listener Was Restarted","LsnrStartOK","DBA613",$tmpfl6);
    }
    if ($F4 eq "LSNRNORESTART:")  
    { 
      &event("C",$thishost,"Listener Restart Failed","LsnrStartNG","DBA614",$tmpfl6);
    }
    if ($F4 eq "LSNRCHMOD:")  
    { 
      &event("I",$thishost,"Permissions changed on listener.ora to 700","LsnrChmod","DBA615",$tmpfl6);
    }
    if ($F4 eq "LSNRPWSET:")  
    { 
      &event("I",$thishost,"Password established on listener.ora","LsnrPwSet","DBA616",$tmpfl6);
    }

    ##print "F0=$F0 F3=$F3 F4=$F4 F5=$F5\n";
  }

  if ($lsnrstat != 1)
  {
    &event("C",$thishost,"Listener Not Active: $lsnrerror","Lsnr","DBA611C",$tmpfl6);
  }
  else
  {
    &logit("OK - lsnr",$thishost);
  }

  if ($tnsping != 1) 
  {
    &event("W",$thishost,"Tnsping failed: $tnserror","TnsPing","DBA612",$tmpfl6);
    system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon oraLsnr() $titleraw[$thishost] TNSPING Failure=$tnserror' $debug_email");
  }
  else
  {
    &logit("OK - tnsping",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
