# -----------------------------------------------------------------------------
sub orantDatafiles
{
  ($thishost) = @_;

  #
  # Check for offline datafiles
  #

  if ($up[$thishost] ne "Y")
  {
    &logit("(down/inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  &remsh("$perlpath[$thishost] $probe[$thishost] $orasid[$thishost] datafiles",$tmpfl3,$thishost);
  &probeLog;

  $msgid = "";
  $downflag = 0;
  $pgmflag = 0;

  open(TMPFL3,  "$tmpfl3") || &error_msg("Can't open output $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;
    if ($F2 eq "OfflineDatafile:") { $downflag = 1; }
    if ($F0 =~ /DoneOK/)           { $pgmflag = 1; }
  }
  close(TMPFL3);

  if (!$pgmflag) 
  {
    system("cat $tmpfl3 | dbamon_mailer -s 'DBAmon orant END_OF_PROBE NF $titleraw[$thishost] LogicErr' $debug_email");
    &event("C",$thishost,"Logic Error - Invoked dbamon_orant.pl Did Not Finish","LogicError","DBA010C",$tmpfl3);
  }

  if ($downflag) 
  {
    &event("C",$thishost,"OFFLINE Datafile(s) Found","OffDFS","DBA648C",$tmpfl3);
  } 
  else
  {
    logit("OK",$thishost);
  }
}


# -----------------------------------------------------------------------------
1;
