sub readPatchAdmin
#--------------------------------------------------------------------------------
#
# readPatchAdmin - Read the patch admin file
#
#--------------------------------------------------------------------------------
# Changes:
#  bb 24Oct04: Initial
#--------------------------------------------------------------------------------
{
  $patch_parmfl = "/opt/dbamon/adm/patchAdmin.txt";

  &msg("Reading patch parm file=$patch_parmfl");

  $dbms_list = "Oracle";
  $risk_levels = "ExtremeRisk|HighRisk|LowRisk";

  open(PATCHPARM, "$patch_parmfl"  ) || &error("Cannot open input $patch_parmfl - $!");
  while (<PATCHPARM>)
  {
    &parse;
    
    if    ($NF == 0)                    { next;}
    elsif ($F1 eq "DBMS:")              { $pa_dbms      = $F2; }
    elsif ($F1 eq "Platform:")          { $pa_platform  = $F2; }
    elsif ($F1 eq "Server_Risk_Level:") { $pa_risklevel = $F2; }
    elsif ($F1 eq "Oracle_Version:")    { $pa_oraver    = $F2; }
    elsif ($F1 eq "Patch_Admin_Email:") 
    { 
      chop($pa_email = substr($F0,index($F0,":") + 1));
    }
    elsif ($F1 eq "Required_Patch_List:") 
    { 
      if (! $pa_risklevel) { &error("patchAdmin.txt: Server_Risk_Level must preceed Required_Patch_List:"); }
      $pa_patchlist = $F2; 
      ##&msg("DEBUGI ($pa_risklevel)($pa_oraver:$pa_patchlist)");
      $pa_hash{"$pa_risklevel:$pa_dbms:$pa_platform:$pa_oraver"} = "$pa_patchlist";
    }
    else
    {
      $msg = sprintf("patchAdmin.txt - Parameter $F1 unknown - rec=$F0\n");
      &error($msg);
    }

    #---- Error checking
    if ($pa_risklevel && $pa_risklevel !~ /$risk_levels/)
    {
      &error("Server_Risk_Level ($pa_risklevel): Must be $risk_levels");
    }
    if ($pa_dbms && $pa_dbms !~ /$dbms_list/)
    {
      &error("DBMS ($pa_dbms): Must be $dbms_list");
    }

  }
  close(PARMALL);

  #&msg("DEBUG pa_email=$pa_email");
  #foreach $thiskey (sort keys %pa_hash) 
  #{
  #  $thisvalue = $pa_hash{$thiskey};
  #  &msg("DEBUG thiskey=$thiskey thisvalue=$thisvalue");
  #}


  #---- Defaults
  #if ($http_details_dir ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Detail_Dir: is obsolete - ignored\n" }
}
# -----------------------------------------------------------------------------
1;
